/*
*********************************************************************************************************
*											        ePDK
*						            the Easy Portable/Player Develop Kits
*									           ir key driver
*
*						        (c) Copyright 2006-2007, Steven.ZGJ China
*											All	Rights Reserved
*
* File    : touchpanel_main.c
* By      : Jerry
* Version : V1.00
*********************************************************************************************************
*/
#include  "drv_touchpanel_i.h"

extern  __touchpanel_drv_t   touchpanel_drv;/* tpÇý¶¯×¢²áÐÅÏ¢  */
extern  _tp_private_data_set_t  tp_private;

__tp_info_set_t tp_info    = {0};/* Ö¸¶¨ÒÆ¶¯¶àÉÙ×÷ÎªÒ»¸ömove¶¯×÷¼°·¢ËÍÏûÏ¢µÄÆµÂÊ */
static __s32 pre_action;
static __ev_tp_msg_t   drv_tp_msg = {0};/* TPÏûÏ¢£¬°üº¬×ø±ê¼°¶¯×÷ÐÅÏ¢ */
static __tp_point_t    tp_point   = {0};
static  __s32      xy_first_point[5] = {0};/* µÚÒ»¸ö²ÉÑùµã */
static  __u32      acount     = 0;/* µ±Ç°²ÉÑùµã´æ·ÅµÄÎ»ÖÃ */
static  __u32      data_index = 0;/* ²ÉÑùµÃµ½µÄ×ÜµãÊý */

__bool    (*tp_isr_task_p)(__s32 irq);
void     (*tp_catch_data)(void);

#define TP_FIRST_DELAY_FILTER (2)

volatile u8 touch_flag=0;
__hdle test_int_pin;

static void touch_isr_init(user_gpio_set_t PinStat);


typedef enum tag_ctp_event
{
    DOWN_EVENT=0,
    UP_EVENT,
    CONTACT_EVENT,
    NO_EVENT,
}ctp_event_t;

/*
     delay_nus
*/
static void delay_nus(__s32 us)
{
    int i;
    while(us--)
    {
        for(i=0; i<60;i++);    
    }   
}

/**********************************************
* function:      fm_iic_write
*
* description:   iic write
*
* notes:         5×Ö½ÚÁ¬ÐøÐ´
*
**********************************************/
	static __s32 ctp_iic_write(__u8 addr, __u8 *buf, __u16 cnt)
	{
		__twi_dev_para_ex_t  piic;
	
		eLIBs_memset(&piic, 0, sizeof(__twi_dev_para_ex_t));
		piic.slave_addr_flag = TWI_SLAVE_ADDRESS_07BIT;
		piic.slave_addr 	 = INPUT_CHIP_DEV_ID;
		piic.byte_addr_width = 1;
		piic.byte_addr		 = &addr;
		piic.data			 = buf;
		piic.byte_count 	 = cnt;
	
		return	eLIBs_fioctrl(tp_private.iic_file , TWI_WRITE_SPEC_RS, 0, (void *)&piic);
	}
	/**********************************************
	* function: 	 fm_iic_read
	*
	* description:	 iic write
	*
	* notes:		 5脳脰陆脷脕卢脨酶露脕
	*
	**********************************************/
	static __s32 ctp_iic_read(__u8	addr, __u8 *buf, __s16 len)
	{
		__twi_dev_para_ex_t  piic;
	
		eLIBs_memset(&piic, 0, sizeof(__twi_dev_para_ex_t));
		piic.slave_addr_flag = TWI_SLAVE_ADDRESS_07BIT;
		piic.slave_addr 	 = INPUT_CHIP_DEV_ID;
		piic.byte_addr_width = 1;
		piic.byte_addr		 = &addr;
		piic.data			 = buf;
		piic.byte_count 	 = len;
	
		return	eLIBs_fioctrl(tp_private.iic_file , TWI_READ_EX_STP_RS, 0, (void *)&piic);
	}



/*  ·¢ËÍÏûÏ¢ÀàÐÍ£¬×ø±ê£¬ËÙ¶ÈºÍ·½Ïò */
static void ctp_send_msg(__input_dev_t *dev, __ev_tp_msg_t *msg)
{
    esINPUT_SendEvent(dev, EV_ABS, ABS_MISC, msg->msg_type);
    esINPUT_SendEvent(dev, EV_ABS, ABS_X, msg->xpoint);
    esINPUT_SendEvent(dev, EV_ABS, ABS_Y, msg->ypoint);
    esINPUT_SendEvent(dev, EV_ABS, ABS_RUDDER, msg->speed_dir);
    esINPUT_SendEvent(dev, EV_ABS, ABS_BRAKE, msg->speed_val);        
 // esINPUT_SendEvent(dev, EV_KEY, BTN_TOUCH, 0);/* KEY UP */
    esINPUT_SendEvent(dev, EV_SYN, SYN_REPORT, 0);    

 //   eLIBs_printf("type = %x, x = %d, y = %d, dir = %x, speed(zoom) = %d \n", 
                      //  msg->msg_type, msg->xpoint, msg->ypoint, msg->speed_dir, msg->speed_val);
}

/*  
*   Í¨¹ý×îºóµÄÑù±¾µã×ö·½ÏòÅÐ¶Ï£¬
*   xy_fp±íÊ¾°´ÏÂµÄµÚÒ»¸ö²ÉÑù×ø±êµã[0]±íÊ¾x×ø±ê£¬[1]±íÊ¾y×ø±ê£¬ÒÔµÚÒ»¸ö×ø±êµã²Î¿¼×ö´¹Ö±»òÕßË®Æ½·½ÏòÅÐ¶Ï¡£
*   
*/
#define TP_FAST_FLICK_PIXEL  (12)
#define TP_SLOW_FLICK_PIXEL  (15) 
static __s32 tp_gesture_recognize(int *data_x, int *data_y, int count,int *xy_fp)
{
    int i;
    int delta;
    int max_x;
    int min_x;
    int max_y;
    int min_y;    
    // maybe fastest flick
    if(count < 2)
    {  
        return 0;//no direction,one point
    }
    // 1.fast flick
    if(count < 7)
    {
        max_x = xy_fp[0];
        min_x = xy_fp[0];
        max_y = xy_fp[1];
        min_y = xy_fp[1];
        
        for(i = 0; i < count; i++)
        {
            max_x = TP_MAX(max_x, data_x[i]);
            min_x = TP_MIN(min_x, data_x[i]);
            max_y = TP_MAX(max_y, data_y[i]);
            min_y = TP_MIN(min_y, data_y[i]);
        }
        //fast flick
        if((max_x-min_x)>(max_y-min_y))/* horizontal */
        {
            if(count > 2)
            {
                delta = data_x[count-1] - data_x[count-3];/* µ¹Êý3¸ö×ø±êµã */
            }
            else
            {
                delta = data_x[count-1] - data_x[count-2];/* µ¹Êý2¸ö×ø±êµã */
            }
            /*  */
            if(TP_ABS(delta)>TP_FAST_FLICK_PIXEL)
            {
                return (delta > 0) ? RIGHTWARD : LEFTWARD;
            }
            else
            {
                return 0;
            }
        }
        else if((max_x-min_x)<(max_y-min_y))/* vertical */
        {
            if(count > 2)
            {
                delta = data_y[count-1] - data_y[count-3];/* µ¹Êý2¸ö×ø±êµã */
            }
            else
            {
                delta = data_y[count-1] - data_y[count-2];/* µ¹Êý2¸ö×ø±êµã */
            }
        
            if(TP_ABS(delta)>TP_FAST_FLICK_PIXEL)
            {
                return (delta > 0) ? DOWNWARD : UPWARD;
            }
            else
            {
                return 0;
            }
        }
        else
        {
            return 0;
        }                
    }
    
    /* equal or more than 7 sample data */
    max_x = xy_fp[0];
    min_x = xy_fp[0];
    max_y = xy_fp[1];
    min_y = xy_fp[1];

    if(count < 11)
    {   
        for(i = count - 7; i < count; i++)
        {
            max_x = TP_MAX(max_x,data_x[i]);
            min_x = TP_MIN(min_x,data_x[i]);
            max_y = TP_MAX(max_y,data_y[i]);
            min_y = TP_MIN(min_y,data_y[i]);
        }
    }
    else
    {
        __u32 index = 0;
        for(i = count - 11; i < count; i++)
        {   
            index = i&TP_DATA_BUFFER_MASK;         
            max_x = TP_MAX(max_x,data_x[index]);
            min_x = TP_MIN(min_x,data_x[index]);
            max_y = TP_MAX(max_y,data_y[index]);
            min_y = TP_MIN(min_y,data_y[index]);
        }
    }
    
    if((max_x-min_x)>(max_y-min_y))/* horizontal */
    {
        __u32 last_1 = (count-1)&TP_DATA_BUFFER_MASK;
        __u32 last_2 = (count-2)&TP_DATA_BUFFER_MASK;
        __u32 last_6 = (count-6)&TP_DATA_BUFFER_MASK;
        __u32 last_7 = (count-7)&TP_DATA_BUFFER_MASK; 
        
        __s32 delta0 = (data_x[last_2] + data_x[last_1]);/* µ¹Êý2¸ö×ø±êµã */
        __s32 delta1 = (data_x[last_7] + data_x[last_6]);/*  */
        if(TP_ABS(delta0-delta1)>TP_SLOW_FLICK_PIXEL)
        {
            return TP_ABS(delta0)>TP_ABS(delta1) ? RIGHTWARD : LEFTWARD;
        }
        else
        {
            return 0;
        }
    }
    else if((max_x-min_x)<(max_y-min_y))/* vertical */
    {
        __u32 last_1 = (count-1)&TP_DATA_BUFFER_MASK;
        __u32 last_2 = (count-2)&TP_DATA_BUFFER_MASK;
        __u32 last_6 = (count-6)&TP_DATA_BUFFER_MASK;
        __u32 last_7 = (count-7)&TP_DATA_BUFFER_MASK;   
    
        __s32 delta0 = (data_y[last_2] + data_y[last_1]);/* µ¹Êý3¸ö×ø±êµã */
        __s32 delta1 = (data_y[last_7] + data_y[last_6]);/*  */

        if(TP_ABS(delta0-delta1)>TP_SLOW_FLICK_PIXEL)
        {
            return TP_ABS(delta0)>TP_ABS(delta1) ? DOWNWARD : UPWARD;
        }
        else
        {
            return 0;
        }
    }
    else
    {
        return 0;
    }
    
}
/*  
*  xy×ø±êbufferµÄÓÐÐ§Êý¾ÝÎª´óÐ¡Îªcount,
*  xy×ø±êµÄ×îºóÒ»×é²ÉÑùÊý¾ÝµÄË÷ÒýÎªcount-1£¬
*  dir±íÊ¾ÔË¶¯µÄ·½Ïò£»
*/
static __u32 tp_flick_speed(int *data_x, int *data_y, int count, int dir)
{        
        __s32 i,delta_x,delta_y;
        __u32 speed = 0;
        __u32 flick = 0;
        
        if(count < 2)
        {
            // 1. fast flick,sample data less than three                                      
            delta_x = TP_ABS(data_x[count-1] - data_x[count-2]);
            delta_y = TP_ABS(data_y[count-1] - data_y[count-2]);            
            flick = 1;
        }
        else if(count < 5)
        {
            // 2. fast flick,sample data less than eight. weight is heavy.             
            delta_x = TP_ABS(data_x[count-1] - data_x[count-3]);
            if(delta_x < TP_ABS(data_x[count-1] - data_x[count-2]))
            {
                delta_x = TP_ABS(data_x[count-1] - data_x[count-2]);
            }
            delta_y = TP_ABS(data_y[count-1] - data_y[count-3]); 
            if(delta_y < TP_ABS(data_y[count-1] - data_y[count-2]))
            {
                delta_y = TP_ABS(data_y[count-1] - data_y[count-2]);
            }
        }
        else
        {        
            __u32 last_1 = (count-1)&TP_DATA_BUFFER_MASK;
            __u32 last_2 = (count-2)&TP_DATA_BUFFER_MASK;    
            // 3. slow flick
            delta_x = TP_ABS(data_x[last_1] - data_x[last_2]);
            delta_y = TP_ABS(data_y[last_1] - data_y[last_2]);
        }
        
        if(dir == UPWARD || dir == DOWNWARD)// vertical 
        {       
            speed = delta_y;   
        }        
        else if(dir == RIGHTWARD || dir == LEFTWARD)// horizontical 
        {     
            speed = delta_x;    
        }
        else
        {
            if((delta_x > 25) && (delta_y > 25))
            {
                return 0;// É¢µã
            }  

            // can't judge direction, may be fast flick 
            if((delta_x > 30) || (delta_y > 30))
            {
                if(flick == 1)
                {
                    speed = 75; // judge as quick flick
                }
                else
                {   
                    speed = 0;
                }                
            }
            else
            {
                speed = 0;
            }            
        }

        // go out
        if(speed > 150)
        {
            speed = 150;
        }
        if(speed < 31)
        {
            speed = 0;// ignore < 6
        }
        
        return (speed/5);              
}

/*  获取采样原始数据?单点 */

/*
typedef enum tag_ctp_event
{
    DOWN_EVENT=0,
    UP_EVENT,
    CONTACT_EVENT,
    NO_EVENT,
}ctp_event_t;
	*/

static  ctp_event_t  touchpanel_get_data(void)
{
	__s32	 ret;
	ctp_event_t event;
	char iic_buf[8];
	static ctp_event_t last_event=NO_EVENT;
	
	
	
	iic_buf[0] = 0x02;
	//ret = ctp_iic_write(0x02, iic_buf, 1);
	ret = ctp_iic_read(0x02, iic_buf, 5);
	if (ret < 0)
	{
		eLIBs_printf("i2c get TP data fail! \n");
	   return NO_EVENT;
	}  
	event =iic_buf[0];
	
	if(event==0)
		{
		if(last_event==NO_EVENT||last_event==UP_EVENT)
			{
			 event=NO_EVENT;
			 last_event=NO_EVENT;
			}else if(last_event==DOWN_EVENT||last_event==CONTACT_EVENT)
				{
				event=UP_EVENT;
				last_event=UP_EVENT;
				}
		}else if(event==1)
			{
			if(last_event==NO_EVENT||last_event==UP_EVENT)
			{
			event=DOWN_EVENT;
			last_event=DOWN_EVENT;
				}else if(last_event==DOWN_EVENT||last_event==CONTACT_EVENT)
					{
			  event=CONTACT_EVENT;
			  last_event=CONTACT_EVENT;
					}
			 
	
			}
	tp_private.xpre = (iic_buf[1]&0x0f)*256 + iic_buf[2];//(480-((iic_buf[1]&0x0f)*256 + iic_buf[2]))*720/480;
	tp_private.ypre = (iic_buf[3]&0x0f)*256 + iic_buf[4];//(480-((iic_buf[3]&0x0f)*256 + iic_buf[4]))*672/480;
	return event;

}
/*
****************************************************************************************************
*
*             tp_catch_data_normal
*
*  Description:   ÆÕÍ¨Ä£Ê½ÏÂµÄÊý¾Ý´¦Àíº¯Êý
*
*  Parameters:
*
*  Return value:
*       EPDK_OK
*       EPDK_FAIL
****************************************************************************************************
*/
void  ctp_catch_data_normal(void)
{
    __s32    ret;
    ctp_event_t event;
    static ctp_event_t old_event = UP_EVENT;
	static u8 first_move=1;
	static u8 first_in;
	static u16 old_x;
	static u16 old_y;


    old_event = UP_EVENT;
	while(1)  /* µ±tp´æ»îÊ±£¬ÕâÊÇÎªÁË±ÜÃâÔÚÒÆ¶¯´¥ÃþµÄÊ±ºò¿ÉÄÜ³öÏÖµÄ´¥ÃþÑ¹Á¦²»×ãµ¼ÖÂÎóÅÐÎªËÉ¿ª */
	{              
	    //fecth sample data
        event = touchpanel_get_data();
    //   eLIBs_printf("event=%d, x = %d y=%d\n", event, tp_private.xpre, tp_private.ypre);
	   if(event==NO_EVENT)
		   {
			   break;
		   }
		  if(event==UP_EVENT)
		  	{
			tp_private.xpre=old_x;	
			tp_private.ypre=old_y;
		  	}else 
		  		{
					old_x=tp_private.xpre;	
					old_y=tp_private.ypre;
		  		}
        if (event == DOWN_EVENT)
        {
	        if(old_event!=DOWN_EVENT)
	        	{
	            drv_tp_msg.xpoint = tp_private.xpre;
                drv_tp_msg.ypoint = tp_private.ypre;        
                drv_tp_msg.msg_type = EV_TP_PRESS_START;       
                drv_tp_msg.speed_dir = 0;
                drv_tp_msg.speed_val = 0;
                ctp_send_msg(touchpanel_drv.tp_input_dev, &drv_tp_msg); 
				old_event=DOWN_EVENT;
		        	}else {
							drv_tp_msg.xpoint = tp_private.xpre;
			                drv_tp_msg.ypoint = tp_private.ypre;        
			                drv_tp_msg.msg_type = EV_TP_PRESS_HOLD;       
			                drv_tp_msg.speed_dir = 0;
			                drv_tp_msg.speed_val = 0;
						    ctp_send_msg(touchpanel_drv.tp_input_dev, &drv_tp_msg);   
							old_event=CONTACT_EVENT;
				}
					
        }
        else if (event == CONTACT_EVENT)
        {
	        if(old_event==DOWN_EVENT||old_event==CONTACT_EVENT)
	        	{
					drv_tp_msg.xpoint = tp_private.xpre;
					drv_tp_msg.ypoint = tp_private.ypre;		
					drv_tp_msg.msg_type = EV_TP_PRESS_HOLD; 	  
					drv_tp_msg.speed_dir = 0;
					drv_tp_msg.speed_val = 0;
					ctp_send_msg(touchpanel_drv.tp_input_dev, &drv_tp_msg);   
					old_event=CONTACT_EVENT;
	        	}else if(old_event==UP_EVENT)
	        		{
			        drv_tp_msg.xpoint = tp_private.xpre;
		            drv_tp_msg.ypoint = tp_private.ypre;        
		            drv_tp_msg.msg_type = EV_TP_PRESS_START;       
		            drv_tp_msg.speed_dir = 0;
		            drv_tp_msg.speed_val = 0;
		            ctp_send_msg(touchpanel_drv.tp_input_dev, &drv_tp_msg);
						old_event=DOWN_EVENT;
	        		}
	        }
        else if (event == UP_EVENT)
        {
          
            if (old_event == CONTACT_EVENT||old_event==DOWN_EVENT)
            {
	          drv_tp_msg.speed_dir =0;
                drv_tp_msg.speed_val =0;               
                drv_tp_msg.msg_type  = EV_TP_ACTION_NULL;
                drv_tp_msg.xpoint = tp_private.xpre;
                drv_tp_msg.ypoint = tp_private.ypre;  
				ctp_send_msg(touchpanel_drv.tp_input_dev, &drv_tp_msg);
	            old_event = UP_EVENT;
			break;
            }
			else 
				if(old_event == UP_EVENT)
            	{
				 break; 	
			}
        }
 
        esKRNL_TimeDly(4);
    }
}
/*
****************************************************************************************************
*
*             touchpanel_main_task
*
*  Description:
*       touchpanel_main_task
*
*  Parameters:
*
*  Return value:
*       none
*
****************************************************************************************************
*/
static void  touchpanel_data_task(void *p_arg)
{
    __u8 err;
    __s32 pin;

    while(1)
    {
       if(touch_flag==1)
	   {
	 //  eLIBs_printf("enter data_task\n");
	   ctp_catch_data_normal();
	   touch_flag=0;
	   esPINS_EnbaleInt(test_int_pin); 
       	}
	    esKRNL_TimeDly(1);
        
    }
}

static __bool touchpanel_main_task(void *arg)
{
    __u8 err;
    __s32 pin;

    while(1)
    {
        if(esKRNL_TDelReq(OS_PRIO_SELF) == OS_TASK_DEL_REQ)
        {
            //É±Ïß³Ì;
            esKRNL_TDel(OS_PRIO_SELF);
        }

        esKRNL_SemPend(tp_private.tp_sem_main, 0, &err);
        pin=esPINS_ReadPinData(tp_private.h_gpio_irq, 0);
        if (pin == 0)
        {
            delay_nus(500);
            pin=esPINS_ReadPinData(tp_private.h_gpio_irq, 0);
            if (pin == 0)
            {
                esKRNL_SemPost(tp_private.tp_sem_data);
                esKRNL_TimeDly(1);
                continue;
            }
        }
        esKRNL_SemPost(tp_private.tp_sem_main);
    }
}

/*
	ctp reset
*/
static void ctp_init(void)
{
    char iic_data;
    __s32 ret;
	__u32 i=0;
    //reset
    if (tp_private.h_gpio_reset)
    {
    __here__;
        esPINS_WritePinData(tp_private.h_gpio_reset, 0, NULL);
        esKRNL_TimeDly(5);
        esPINS_WritePinData(tp_private.h_gpio_reset, 1, NULL);        
    }

    while(1)
    {
        iic_data = 0x00;
        ret = ctp_iic_write(0x00, &iic_data, 1); 
        if (ret==0)
            break;
		i++;
		if(i>5)
			{
			break;
			}
        esKRNL_TimeDly(5);
    }

	return;
}

/*
****************************************************************************************************
*
*             touchpanel_init
*
*  Description:
*       touchpanel_init
*
*  Parameters:
*
*  Return value:
*       none
*
****************************************************************************************************
*/

//#define TP_TWO_POINT

__s32 touchpanel_init(void)
{
    __s32 ret;
	__s32 if_reverse;
    user_gpio_set_t gpio_set;
	user_gpio_set_t gpio_set_1[3];
	__hdle SDA_h,SCL_h;
    
    __here__;
    eLIBs_memset(&tp_private, 0, sizeof(_tp_private_data_set_t));

    if(esCFG_GetKeyValue("tp_para", "if_reverse", (__s32 *)&if_reverse, 1))
    {
        __wrn("fetch para from script failed: if_reverse\n");
    }

    ret = esCFG_GetKeyValue("tp_para", "tp_reset", (int *)&gpio_set, sizeof(user_gpio_set_t)/4);
    if (ret)
    {
        __wrn("fetch para from script failed: tp_reset\n");
    }
    else
    {
        tp_private.h_gpio_reset = esPINS_PinGrpReq(&gpio_set, 1);
        if (!tp_private.h_gpio_reset)
        {
            __wrn("request tp reset pin failed\n");
    //      goto err_out;
        }
    }

    
    
     ret = esCFG_GetKeyValue("tp_para", "tp_irq", (int *)&gpio_set, sizeof(user_gpio_set_t)/4);
    if (ret)
    {
        __wrn("fetch para from script failed: tp_irq\n");
    }
    else
    {
    
           touch_isr_init(gpio_set); 
          //private.h_gpio_irq = esPINS_PinGrpReq(&gpio_set, 1);
        if (!tp_private.h_gpio_irq)
        {
            __wrn("request tp irq pin failed\n");
    //      goto err_out;
        }
    }
    
    ret = esCFG_GetKeyValue("tp_para", "tp_scl", (int *)&gpio_set_1[1], sizeof(user_gpio_set_t)/4);
    if (ret)
    {
        eLIBs_printf("fetch para from script failed: tp_scl\n");
    }
	
    ret = esCFG_GetKeyValue("tp_para", "tp_sda", (int *)&gpio_set_1[2], sizeof(user_gpio_set_t)/4);
    if (ret)
    {
        eLIBs_printf("fetch para from script failed: tp_sda\n");
    }

	SCL_h=OSAL_GPIO_Request(&gpio_set_1[1], 1);
	SDA_h=OSAL_GPIO_Request(&gpio_set_1[2], 1);

		

	if (if_reverse & 0x04)
		tp_private.x_y_change = 1;
	if (if_reverse & 0x02)
		tp_private.y_pol = 1;
	if (if_reverse & 0x01)
		tp_private.x_pol = 1;

	 tp_private.iic_file = eLIBs_fopen("b:\\BUS\\TWI2", "r+");
	if(!tp_private.iic_file)
	{
		__wrn("Open TWI Dev File Failed\n");

		return EPDK_FAIL;
	}
    eLIBs_fioctrl(tp_private.iic_file, TWI_SET_SCL_CLOCK, 0, (void *)TWI_SCLK_300KHZ); 
    __msg("iic_file = %x\n", tp_private.iic_file);
    ctp_init();
    __here__;
    tp_info.pertime = TP_DEFAULT_MSG_PERTIME;  //¼ä¸ô5´Î²ÉÑù·¢ËÍÒ»¸öÏûÏ¢
    tp_info.offset  = TP_DEFAULT_OFFSET;       //x»òÕßy·½ÏòÆ«²î³¬¹ý7¸öÏñËØÈÏÎªÊÇÒ»¸ömove¶¯×÷
    
    tp_private.tp_sem_main  = esKRNL_SemCreate(1);
    tp_private.tp_sem_data  = esKRNL_SemCreate(0);
  //  tp_private.main_tid = esKRNL_TCreate(touchpanel_main_task, 0, 0x800, KRNL_priolevel6);
      tp_private.data_tid = esKRNL_TCreate(touchpanel_data_task, 0, 0x800, KRNL_priolevel3);

  
    //esINT_InsISR(INTC_IRQNO_PIO, ctp_isr_task, 0);
    //esINT_EnableINT(INTC_IRQNO_PIO);
    
    __wrn("tp init finish\n");
    return EPDK_OK;
}

static void touch_handle(void *arg)
{
//	eLIBs_printf("enter touch handle\n");
if(touch_flag==0)
{
	touch_flag=1;
    esPINS_DisbaleInt(test_int_pin);
	esKRNL_TimeDlyResume (tp_private.data_tid);
}
}

static void touch_isr_init(user_gpio_set_t PinStat)
{

__s32  ret;

PinStat.mul_sel= 6;

PinStat.pull=1;


test_int_pin= esPINS_PinGrpReq(&PinStat, 1);
if(test_int_pin)
{
  eLIBs_printf("request extern int port=%d port_num=%d succeed \n",PinStat.port,PinStat.port_num);
}else 
{
  eLIBs_printf("request?extern?int fail \n");
}
  ret=esPINS_SetIntMode(test_int_pin,PIN_INT_NEGATIVE_EDGE);
if(EPDK_FAIL==ret)
{
  eLIBs_printf("set int mode fail \n");
}else 
{
  eLIBs_printf("set int mode success \n");
}
ret=esPINS_RegIntHdler(test_int_pin,touch_handle,NULL);
if(EPDK_FAIL==ret)
{
   eLIBs_printf("set int hadler fail \n");
}else 
{
   eLIBs_printf("set int hader success \n");
}

 ret =esPINS_EnbaleInt(test_int_pin); 

if(EPDK_FAIL==ret)
{
    eLIBs_printf("enableint fail \n");
}else 
{
   eLIBs_printf("enableint  success \n");
}
}
/*
****************************************************************************************************
*
*             touchpanel_exit
*
*  Description:
*       touchpanel_exit
*
*  Parameters:
*
*  Return value:
*       none
*
****************************************************************************************************
*/
__s32 touchpanel_exit(void)
{
    __u8  err;

    if (tp_private.h_gpio_reset)
    {
        esPINS_PinGrpRel(tp_private.h_gpio_reset, 0);
        tp_private.h_gpio_reset = NULL;
    }

    if (tp_private.h_gpio_irq)
    {
        esPINS_PinGrpRel(tp_private.h_gpio_irq, 0);
        tp_private.h_gpio_irq = NULL;
    }

    if(tp_private.data_tid)
    {
        esKRNL_SemPost(tp_private.tp_sem_data);
        esKRNL_TDel(tp_private.data_tid);
        esKRNL_TimeDly(4);
    }

    if(tp_private.main_tid)
    {
        esKRNL_SemPost(tp_private.tp_sem_main);
        esKRNL_TDel(tp_private.main_tid);
        esKRNL_TimeDly(4);
    }

	if(tp_private.iic_file)
	{
		eLIBs_fclose(tp_private.iic_file);
	}

    esKRNL_SemDel(tp_private.tp_sem_main, OS_DEL_ALWAYS, &err);
    esKRNL_SemDel(tp_private.tp_sem_data, OS_DEL_ALWAYS, &err);

    __wrn("tp exit\n");

    return EPDK_OK;
}
